/* $Id: rpmver.c,v 1.1 2011/09/12 12:14:58 heinz Exp $
 *
 * camlrpm - an ocaml interface to some rpmlib functions
 *
 * Copyright (C) 2005 Heinz Deinhart
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <caml/mlvalues.h>
#include <rpmlib.h>
#include <assert.h>
#include <string.h>

CAMLprim value
rpm_vercmp( value ver1, value ver2 )
{
        char *str1, *str2;
        int len;

        len = string_length( ver1 );
        str1 = alloca( len + 1 );
        assert( str1 );
        memcpy( str1, String_val( ver1 ), len );
        str1[len] = '\0';
        len = string_length( ver2 );
        str2 = alloca( len + 1 );
        assert( str2 );
        memcpy( str2, String_val( ver2 ), len );
        str2[len] = '\0';

        return Val_int( rpmvercmp( str1, str2 ));
}

